%

%
% Copyright (c) 2015 LAAS/CNRS
% All rights reserved.
%
% Redistribution  and  use  in  source  and binary  forms,  with  or  without
% modification, are permitted provided that the following conditions are met:
%
%   1. Redistributions of  source  code must retain the  above copyright
%      notice and this list of conditions.
%   2. Redistributions in binary form must reproduce the above copyright
%      notice and  this list of  conditions in the  documentation and/or
%      other materials provided with the distribution.
%
% THE SOFTWARE  IS PROVIDED "AS IS"  AND THE AUTHOR  DISCLAIMS ALL WARRANTIES
% WITH  REGARD   TO  THIS  SOFTWARE  INCLUDING  ALL   IMPLIED  WARRANTIES  OF
% MERCHANTABILITY AND  FITNESS.  IN NO EVENT  SHALL THE AUTHOR  BE LIABLE FOR
% ANY  SPECIAL, DIRECT,  INDIRECT, OR  CONSEQUENTIAL DAMAGES  OR  ANY DAMAGES
% WHATSOEVER  RESULTING FROM  LOSS OF  USE, DATA  OR PROFITS,  WHETHER  IN AN
% ACTION OF CONTRACT, NEGLIGENCE OR  OTHER TORTIOUS ACTION, ARISING OUT OF OR
% IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
%
%                                           Anthony Mallet on Wed Jul  8 2015
%
function tk3_action(block)
  tk3_mask(block, 0);
  user = get_param(block, 'UserData');

  switch user.param.device
    case 'Brushless controller'
      error 'Device has no gyroscopes';
  end
  client = tk3.client('mkfl', user.param.serial, str2num(user.param.speed));

  d = str2num(user.param.gcaliblen);
  client.gyro_calibrate(d);

  names = get_param(block, 'MaskNames');
  enables = get_param(block, 'MaskEnables');
  index = find(strcmp(names, 'gcaliblen'));

  enables{index} = 'off';
  set_param(block, 'MaskEnables', enables);
  pause(d);
  enables{index} = 'on';
  set_param(block, 'MaskEnables', enables);

  delete(client);
end
